import iotcloud.*;
import java.util.*;

class LightsController {

    public static void main(String[] args) throws Exception {

        Table t1 = new Table("http://dc-6.calit2.uci.edu/test.iotcloud/", "reallysecret", 321, -1);
        t1.rebuild();

        // Bulb 1
        byte[] bulbMacAdd1 = new byte[8];
        bulbMacAdd1[0] = (byte)0xD0;
        bulbMacAdd1[1] = (byte)0x73;
        bulbMacAdd1[2] = (byte)0xD5;
        bulbMacAdd1[3] = (byte)0x11;
        bulbMacAdd1[4] = (byte)0x42;
        bulbMacAdd1[5] = (byte)0xE5;
        bulbMacAdd1[6] = (byte)0x00;
        bulbMacAdd1[7] = (byte)0x00;

        IoTDeviceAddress devAddr1 = new IoTDeviceAddress("192.168.1.4", 56700, 56700, false, false);
        IoTUDP udp1 = new IoTUDP(devAddr1);
        LightBulb bulb1 = new LifxLightBulb(udp1, bulbMacAdd1);



        byte[] bulbMacAdd2 = new byte[8];
        bulbMacAdd2[0] = (byte)0xD0;
        bulbMacAdd2[1] = (byte)0x73;
        bulbMacAdd2[2] = (byte)0xD5;
        bulbMacAdd2[3] = (byte)0x12;
        bulbMacAdd2[4] = (byte)0x8E;
        bulbMacAdd2[5] = (byte)0x30;
        bulbMacAdd2[6] = (byte)0x00;
        bulbMacAdd2[7] = (byte)0x00;

        IoTDeviceAddress devAddr2 = new IoTDeviceAddress("192.168.1.32", 56701, 56700, false, false);
        IoTUDP udp2 = new IoTUDP(devAddr2);
        LightBulb bulb2 = new LifxLightBulb(udp2, bulbMacAdd2);



        byte[] bulbMacAdd3 = new byte[8];
        bulbMacAdd3[0] = (byte)0xD0;
        bulbMacAdd3[1] = (byte)0x73;
        bulbMacAdd3[2] = (byte)0xD5;
        bulbMacAdd3[3] = (byte)0x02;
        bulbMacAdd3[4] = (byte)0x41;
        bulbMacAdd3[5] = (byte)0xDA;
        bulbMacAdd3[6] = (byte)0x00;
        bulbMacAdd3[7] = (byte)0x00;

        IoTDeviceAddress devAddr3 = new IoTDeviceAddress("192.168.1.33", 56702, 56700, false, false);
        IoTUDP udp3 = new IoTUDP(devAddr3);
        LightBulb bulb3 = new LifxLightBulb(udp3, bulbMacAdd3);


        List<LightBulb> bulbs = new ArrayList<LightBulb>();
        bulbs.add(bulb1);
        bulbs.add(bulb2);
        bulbs.add(bulb3);


        String a1 = "bulb1";
        String a2 = "bulb2";
        String a3 = "bulb3";

        IoTString ia1 = new IoTString(a1);
        IoTString ia2 = new IoTString(a2);
        IoTString ia3 = new IoTString(a3);


        List<IoTString> keys = new ArrayList<IoTString>();
        keys.add(ia1);
        keys.add(ia2);
        keys.add(ia3);


        String valueA = "on";
        IoTString iValueA = new IoTString(valueA);


        String pingTimerKey = "bulbController";
        IoTString ipingTimerKey = new IoTString(pingTimerKey);



        System.out.println("Starting System");
        int counter = 0;

        while (true) {

            try {

                counter++;
                if (counter == 10) {
                    counter = 0;

                    String pingTimer = Long.toString(System.currentTimeMillis());
                    IoTString ipingTimer = new IoTString(pingTimer);

                    t1.update();
                    t1.startTransaction();
                    t1.addKV(ipingTimerKey, ipingTimer);
                    t1.commitTransaction();
                }


                t1.update();
                Thread.sleep(1000);

                for (int i = 0; i < 3; i++) {
                    IoTString testValA1 = t1.getCommitted(keys.get(i));
                    if ((testValA1 != null) && (testValA1.equals(iValueA) == true)) {
                        bulbs.get(i).turnOn();
                    } else {
                        bulbs.get(i).turnOff();
                    }
                }

            } catch (Error e) {

                e.printStackTrace();
                for (int i = 0; i < 3; i++) {
                    bulbs.get(i).setColor(0, 100, 100);
                }



                while (true) {
                    for (int i = 0; i < 3; i++) {
                        bulbs.get(i).turnOff();
                    }
                    Thread.sleep(1000);

                    for (int i = 0; i < 3; i++) {
                        bulbs.get(i).turnOn();
                    }
                    Thread.sleep(1000);
                }
            }
        }
    }
}